// Facility Location
import int+ NbFacility;    // Number of facilities  
import int+ NbClient;      // Number of clients

range Facility 1..NbFacility;
range Client 1..NbClient;

import float FixedCost[Facility];            // Fixed setup cost
import float ServiceCost[Facility,Client];   // Service cost

var int y[Facility] in 0..1;             // Decision to setup facility
var float x[Facility,Client] in 0..1;    // Decision to service client from facility

minimize
   sum(f in Facility) FixedCost[f]*y[f] +
      sum(f in Facility) ( sum(c in Client) (ServiceCost[f,c]*x[f,c] ))    // objective

subject to
{
      forall(c in Client)
         sum(f in Facility) x[f,c] = 1;   // all clients are served
                 
      forall(f in Facility)
         forall(c in Client)
            x[f,c] <= y[f];               // can only service if setup 
};

setting cplexLogFile = "cplexFL.log";

//setting implBd = -1;
//setting flowCovers = -1;
//setting fracCuts = -1;